Merge "Updated function test env with new tests and features"
[nonrtric.git] / test / common / testcase_common.sh
index 088995f..4818bc0 100755 (executable)
@@ -20,6 +20,7 @@
 # This is a script that contains all the functions needed for auto test
 # Arg: local|remote|remote-remove [auto-clean]
 
+
 #Formatting for 'echo' cmd
 BOLD="\033[1m"
 EBOLD="\033[0m"
@@ -29,9 +30,27 @@ GREEN="\033[32m\033[1m"
 EGREEN="\033[0m"
 YELLOW="\033[33m\033[1m"
 EYELLOW="\033[0m"
+SAMELINE="\033[0K\r"
+
+tmp=$(which python3)
+if [ $? -ne 0 ] || [ -z tmp ]; then
+       echo -e $RED"python3 is required to run the test environment, pls install"$ERED
+       exit 1
+fi
+tmp=$(which docker)
+if [ $? -ne 0 ] || [ -z tmp ]; then
+       echo -e $RED"docker is required to run the test environment, pls install"$ERED
+       exit 1
+fi
+
+tmp=$(which docker-compose)
+if [ $? -ne 0 ] || [ -z tmp ]; then
+       echo -e $RED"docker-compose is required to run the test environment, pls install"$ERED
+       exit 1
+fi
 
 # Just resetting any previous echo formatting...
-echo -ne $EBOLD$ERED$EGREEN
+echo -ne $EBOLD
 
 # source test environment variables
 . ../common/test_env.sh
@@ -46,15 +65,35 @@ G1_COUNT=0
 G2_COUNT=0
 G3_COUNT=0
 
+# Vars to switch between http and https. Extra curl flag needed for https
+export RIC_SIM_HTTPX="http"
+export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
+export RIC_SIM_PORT=$RIC_SIM_INTERNAL_PORT
+export RIC_SIM_CERT_MOUNT_DIR="./cert"
+
+export MR_HTTPX="http"
+export MR_PORT=$MR_INTERNAL_PORT
+export MR_LOCAL_PORT=$MR_EXTERNAL_PORT #When agent is running outside the docker net
+
+export SDNC_HTTPX="http"
+export SDNC_PORT=$SDNC_INTERNAL_PORT
+export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_PORT #When agent is running outside the docker net
+
 #Localhost constant
 LOCALHOST="http://localhost:"
 
 # Make curl retries for http response codes set in this env var, space separated list of codes
 AGENT_RETRY_CODES=""
 
+# Var to contol if the agent runs in a container (normal = 0) or as application on the local machine ( = 1)
+AGENT_STAND_ALONE=0
+
 # Var to hold 'auto' in case containers shall be stopped when test case ends
 AUTO_CLEAN=""
 
+# Var to hold the app names to use local image for when running 'remote' or 'remote-remove'
+USE_LOCAL_IMAGES=""
+
 # Set a description string for the test case
 if [ -z "$TC_ONELINE_DESCR" ]; then
        TC_ONELINE_DESCR="<no-description>"
@@ -99,10 +138,20 @@ RES_TEST=0
 RES_PASS=0
 RES_FAIL=0
 RES_CONF_FAIL=0
+RES_DEVIATION=0
+
+#File to keep deviation messages
+DEVIATION_FILE=".tmp_deviations"
+rm $DEVIATION_FILE &> /dev/null
 
 #Var for measuring execution time
 TCTEST_START=$SECONDS
 
+#File to save timer measurement results
+TIMER_MEASUREMENTS=".timer_measurement.txt"
+echo -e "Activity \t Duration" > $TIMER_MEASUREMENTS
+
+
 echo "-------------------------------------------------------------------------------------------------"
 echo "-----------------------------------      Test case: "$ATC
 echo "-----------------------------------      Started:   "$(date)
@@ -111,6 +160,42 @@ echo "-- Description: "$TC_ONELINE_DESCR
 echo "-------------------------------------------------------------------------------------------------"
 echo "-----------------------------------      Test case setup      -----------------------------------"
 
+START_ARG=$1
+paramerror=0
+if [ $# -lt 1 ]; then
+       paramerror=1
+fi
+if [ $paramerror -eq 0 ]; then
+       if [ "$1" != "remote" ] && [ "$1" != "remote-remove" ] && [ "$1" != "local" ]; then
+               paramerror=1
+       else
+               shift;
+       fi
+fi
+if [ $paramerror -eq 0 ]; then
+       if [ "$1" == "auto-clean" ]; then
+               AUTO_CLEAN="auto"
+               shift;
+       fi
+fi
+if [ $paramerror -eq 0 ]; then
+       if [ "$1" == "-use-local-image" ]; then
+               USE_LOCAL_IMAGES=${@:2}
+               while [ $# -gt 0 ]; do
+                       shift;
+               done
+       fi
+fi
+
+if [ $paramerror -eq 0 ] && [ $# -gt 0 ]; then
+       paramerror=1
+fi
+
+if [ $paramerror -eq 1 ]; then
+       echo -e $RED"Expected arg: local|remote|remote-remove [auto-clean] [-use-local-image <app-nam> [<app-name>]]"$ERED
+       exit 1
+fi
+
 echo -e $BOLD"Checking configured image setting for this test case"$EBOLD
 
 #Temp var to check for image variable name errors
@@ -155,60 +240,100 @@ __check_image_var() {
        #echo " Configured image for ${1} (script start arg=${2}): "$image":"$tag
 }
 
+
+#Check if app local image shall override remote image
+check_image_local_override() {
+       for im in $USE_LOCAL_IMAGES; do
+               if [ "$1" == "$im" ]; then
+                       return 1
+               fi
+       done
+       return 0
+}
+
+#Check if app uses image excluded from this test run
+check_excluded_image() {
+       for im in $EXCLUDED_IMAGES; do
+               if [ "$1" == "$im" ]; then
+                       return 1
+               fi
+       done
+       return 0
+}
+
 # Check that image env setting are available
 echo ""
-if [ $# -lt 1 ] || [ $# -gt 2 ]; then
-       echo "Expected arg: local|remote|remote-remove [auto-clean]"
-       exit 1
-elif [ $1 == "local" ]; then
+
+if [ $START_ARG == "local" ]; then
 
        #Local agent image
-       __check_image_var " Policy Agent" $1 "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG"
+       __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG"
 
        #Local Control Panel image
-       __check_image_var " Control Panel" $1 "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG"
+       __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG"
 
        #Local SNDC image
-       __check_image_var " SDNC A1 Controller" $1 "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG"
+       __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG"
 
        #Local ric sim image
-       __check_image_var " RIC Simulator" $1 "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG"
+       __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG"
 
-elif [ $1 == "remote" ] || [ $1 == "remote-remove" ]; then
+elif [ $START_ARG == "remote" ] || [ $START_ARG == "remote-remove" ]; then
 
-       #Remote agent image
-       __check_image_var " Policy Agent" $1 "POLICY_AGENT_IMAGE" "POLICY_AGENT_REMOTE_IMAGE" "POLICY_AGENT_REMOTE_IMAGE_TAG"
+       check_image_local_override 'PA'
+       if [ $? -eq 0 ]; then
+               #Remote agent image
+               __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_REMOTE_IMAGE" "POLICY_AGENT_REMOTE_IMAGE_TAG"
+       else
+               #Local agent image
+               __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG"
+       fi
 
-       #Remote Control Panel image
-       __check_image_var " Control Panel" $1 "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE_TAG"
+       check_image_local_override 'CP'
+       if [ $? -eq 0 ]; then
+               #Remote Control Panel image
+               __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE_TAG"
+       else
+               #Local Control Panel image
+               __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG"
+       fi
 
-       #Remote SDNC image
-       __check_image_var " SDNC A1 Controller" $1 "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE_TAG"
+       check_image_local_override 'SDNC'
+       if [ $? -eq 0 ]; then
+               #Remote SDNC image
+               __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE_TAG"
+       else
+               #Local SNDC image
+               __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG"
+       fi
 
-       #Remote ric sim image
-       __check_image_var " RIC Simulator" $1 "RIC_SIM_IMAGE" "RIC_SIM_REMOTE_IMAGE" "RIC_SIM_REMOTE_IMAGE_TAG"
+       check_image_local_override 'RICSIM'
+       if [ $? -eq 0 ]; then
+               #Remote ric sim image
+               __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_REMOTE_IMAGE" "RIC_SIM_REMOTE_IMAGE_TAG"
+       else
+               #Local ric sim image
+               __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG"
+       fi
 
 else
-       echo "Expected arg: local|remote|remote-remove [auto-clean]"
+       #Should never get here....
+       echo "Unknow args: "$@
        exit 1
 fi
 
-if [ $# -eq 2 ]; then
-       if [ $2 == "auto-clean" ]; then
-               echo "Stting automatic cleaning of container when test case ends"
-               AUTO_CLEAN="auto"
-       else
-               echo "Expected arg: local|remote|remote-remove [auto-clean]"
-               exit 1
-       fi
-fi
 
 # These images are not built as part of this project official images, just check that env vars are set correctly
-__check_image_var " Message Router" $1 "MRSTUB_IMAGE" "MRSTUB_LOCAL_IMAGE" "MRSTUB_LOCAL_IMAGE_TAG"
-__check_image_var " Callback Receiver" $1 "CR_IMAGE" "CR_LOCAL_IMAGE" "CR_LOCAL_IMAGE_TAG"
-__check_image_var " Consul" $1 "CONSUL_IMAGE" "CONSUL_REMOTE_IMAGE" "CONSUL_REMOTE_IMAGE_TAG"
-__check_image_var " CBS" $1 "CBS_IMAGE" "CBS_REMOTE_IMAGE" "CBS_REMOTE_IMAGE_TAG"
-__check_image_var " SDNC DB" $1 "SDNC_DB_IMAGE" "SDNC_DB_REMOTE_IMAGE" "SDNC_DB_REMOTE_IMAGE_TAG"
+__check_image_var " Message Router" $START_ARG "MRSTUB_IMAGE" "MRSTUB_LOCAL_IMAGE" "MRSTUB_LOCAL_IMAGE_TAG"
+__check_image_var " Callback Receiver" $START_ARG "CR_IMAGE" "CR_LOCAL_IMAGE" "CR_LOCAL_IMAGE_TAG"
+__check_image_var " Consul" $START_ARG "CONSUL_IMAGE" "CONSUL_REMOTE_IMAGE" "CONSUL_REMOTE_IMAGE_TAG"
+__check_image_var " CBS" $START_ARG "CBS_IMAGE" "CBS_REMOTE_IMAGE" "CBS_REMOTE_IMAGE_TAG"
+__check_image_var " SDNC DB" $START_ARG "SDNC_DB_IMAGE" "SDNC_DB_REMOTE_IMAGE" "SDNC_DB_REMOTE_IMAGE_TAG"
+check_excluded_image 'SDNC_ONAP'
+if [ $? -eq 0 ]; then
+       __check_image_var " SDNC ONAP A1 Adapter" $START_ARG "SDNC_ONAP_A1_ADAPTER_IMAGE" "SDNC_ONAP_A1_ADAPTER_REMOTE_IMAGE" "SDNC_ONAP_A1_ADAPTER_REMOTE_IMAGE_TAG"
+       __check_image_var " SDNC ONAP DB" $START_ARG "SDNC_ONAP_DB_IMAGE" "SDNC_ONAP_DB_REMOTE_IMAGE" "SDNC_ONAP_DB_REMOTE_IMAGE_TAG"
+fi
 
 #Errors in image setting - exit
 if [ $IMAGE_ERR -ne 0 ]; then
@@ -216,7 +341,7 @@ if [ $IMAGE_ERR -ne 0 ]; then
 fi
 
 #Print a tables of the image settings
-echo -e $BOLD"Images configured for start arg: "$1 $EBOLD
+echo -e $BOLD"Images configured for start arg: "$START $EBOLD
 column -t -s $'\t' $image_list_file
 
 echo ""
@@ -263,37 +388,40 @@ __check_and_pull_image() {
                fi
        elif [ $1 == "remote" ] || [ $1 == "remote-remove" ]; then
                if [ $1 == "remote-remove" ]; then
-                       echo -ne "  Attempt to stop and remove container(s), if running - \033[0K\r"
+                       echo -ne "  Attempt to stop and remove container(s), if running - ${SAMELINE}"
                        tmp="$(docker ps -aq --filter name=${3})"
                        if [ $? -eq 0 ] && [ ! -z "$tmp" ]; then
-                               docker stop $tmp &> /dev/null
+                               docker stop $tmp &> .dockererr
                                if [ $? -ne 0 ]; then
                                        ((IMAGE_ERR++))
                                        echo ""
                                        echo -e $RED"  Container(s) could not be stopped - try manual stopping the container(s)"$ERED
+                                       cat .dockererr
                                        return 1
                                fi
                        fi
-                       echo -ne "  Attempt to stop and remove container(s), if running - "$GREEN"stopped"$EGREEN"\033[0K\r"
+                       echo -ne "  Attempt to stop and remove container(s), if running - "$GREEN"stopped"$EGREEN"${SAMELINE}"
                        tmp="$(docker ps -aq --filter name=${3})" &> /dev/null
                        if [ $? -eq 0 ] && [ ! -z "$tmp" ]; then
-                               docker rm $tmp &> /dev/null
+                               docker rm $tmp &> .dockererr
                                if [ $? -ne 0 ]; then
                                        ((IMAGE_ERR++))
                                        echo ""
                                        echo -e $RED"  Container(s) could not be removed - try manual removal of the container(s)"$ERED
+                                       cat .dockererr
                                        return 1
                                fi
                        fi
                        echo -e "  Attempt to stop and remove container(s), if running - "$GREEN"stopped removed"$EGREEN
-                       echo -ne "  Removing image - \033[0K\r"
+                       echo -ne "  Removing image - ${SAMELINE}"
                        tmp="$(docker images -q ${4})" &> /dev/null
                        if [ $? -eq 0 ] && [ ! -z "$tmp" ]; then
-                               docker rmi $4 &> /dev/null
+                               docker rmi $4 &> .dockererr
                                if [ $? -ne 0 ]; then
                                        ((IMAGE_ERR++))
                                        echo ""
                                        echo -e $RED"  Image could not be removed - try manual removal of the image"$ERED
+                                       cat .dockererr
                                        return 1
                                fi
                                echo -e "  Removing image - "$GREEN"removed"$EGREEN
@@ -303,13 +431,14 @@ __check_and_pull_image() {
                        tmp_im=""
                fi
                if [ -z "$tmp_im" ]; then
-                       echo -ne "  Pulling image\033[0K\r"
-                       docker pull $4   > /dev/null
+                       echo -ne "  Pulling image${SAMELINE}"
+                       docker pull $4  &> .dockererr
                        tmp_im=$(docker images ${4} | grep -v REPOSITORY)
                        if [ -z "$tmp_im" ]; then
                                echo ""
                                echo -e "  Pulling image -$RED could not be pulled"$ERED
                                ((IMAGE_ERR++))
+                               cat .dockererr
                                return 1
                        fi
                        echo -e "  Pulling image -$GREEN Pulled $EGREEN"
@@ -323,15 +452,48 @@ __check_and_pull_image() {
 
 echo -e $BOLD"Pulling configured images, if needed"$EBOLD
 
-app="Policy Agent";             __check_and_pull_image $1 "$app" $POLICY_AGENT_APP_NAME $POLICY_AGENT_IMAGE
-app="Non-RT RIC Control Panel"; __check_and_pull_image $1 "$app" $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_IMAGE
-app="SDNC A1 Controller";       __check_and_pull_image $1 "$app" $SDNC_APP_NAME $SDNC_A1_CONTROLLER_IMAGE
-app="Near-RT RIC Simulator";    __check_and_pull_image $1 "$app" $RIC_SIM_PREFIX"_"$RIC_SIM_BASE $RIC_SIM_IMAGE
+START_ARG_MOD=$START_ARG
+check_image_local_override 'PA'
+if [ $? -eq 1 ]; then
+       START_ARG_MOD="local"
+fi
+app="Policy Agent";             __check_and_pull_image $START_ARG_MOD "$app" $POLICY_AGENT_APP_NAME $POLICY_AGENT_IMAGE
 
-app="Consul";                   __check_and_pull_image $1 "$app" $CONSUL_APP_NAME $CONSUL_IMAGE
-app="CBS";                      __check_and_pull_image $1 "$app" $CBS_APP_NAME $CBS_IMAGE
-app="SDNC DB";                  __check_and_pull_image $1 "$app" $SDNC_APP_NAME $SDNC_DB_IMAGE
+START_ARG_MOD=$START_ARG
+check_image_local_override 'CP'
+if [ $? -eq 1 ]; then
+       START_ARG_MOD="local"
+fi
+app="Non-RT RIC Control Panel"; __check_and_pull_image $START_ARG_MOD "$app" $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_IMAGE
 
+START_ARG_MOD=$START_ARG
+check_image_local_override 'RICSIM'
+if [ $? -eq 1 ]; then
+       START_ARG_MOD="local"
+fi
+app="Near-RT RIC Simulator";    __check_and_pull_image $START_ARG_MOD "$app" $RIC_SIM_PREFIX"_"$RIC_SIM_BASE $RIC_SIM_IMAGE
+
+app="Consul";                   __check_and_pull_image $START_ARG "$app" $CONSUL_APP_NAME $CONSUL_IMAGE
+app="CBS";                      __check_and_pull_image $START_ARG "$app" $CBS_APP_NAME $CBS_IMAGE
+check_excluded_image 'SDNC'
+if [ $? -eq 0 ]; then
+       START_ARG_MOD=$START_ARG
+       check_image_local_override 'SDNC'
+       if [ $? -eq 1 ]; then
+               START_ARG_MOD="local"
+       fi
+       app="SDNC A1 Controller";       __check_and_pull_image $START_ARG_MOD "$app" $SDNC_APP_NAME $SDNC_A1_CONTROLLER_IMAGE
+       app="SDNC DB";                  __check_and_pull_image $START_ARG "$app" $SDNC_APP_NAME $SDNC_DB_IMAGE
+else
+       echo -e $YELLOW" Excluding SDNC image and related DB image from image check/pull"$EYELLOW
+fi
+check_excluded_image 'SDNC_ONAP'
+if [ $? -eq 0 ]; then
+       app="SDNC ONAP A1 Adapter";     __check_and_pull_image $START_ARG "$app" $SDNC_ONAP_APP_NAME $SDNC_ONAP_A1_ADAPTER_IMAGE
+       app="SDNC ONAP DB";             __check_and_pull_image $START_ARG "$app" $SDNC_ONAP_APP_NAME $SDNC_ONAP_DB_IMAGE
+else
+       echo -e $YELLOW" Excluding ONAP SDNC image and related DB image from image check/pull"$EYELLOW
+fi
 # MR stub image not checked, will be built by this script - only local image
 # CR stub image not checked, will be built by this script - only local image
 
@@ -341,6 +503,7 @@ if [ $IMAGE_ERR -ne 0 ]; then
        echo ""
        echo "#################################################################################################"
        echo -e $RED"One or more images could not be pulled or containers using the images could not be stopped/removed"$ERED
+       echo -e $RED"Or local image, overriding remote image, does not exist"$ERED
        echo "#################################################################################################"
        echo ""
        exit 1
@@ -354,23 +517,25 @@ curdir=$PWD
 cd $curdir
 cd ../mrstub
 echo " Building mrstub image: mrstub:latest"
-docker build -t mrstub . &> /dev/null
+docker build -t mrstub . &> .dockererr
 if [ $? -eq 0 ]; then
        echo -e  $GREEN" Build Ok"$EGREEN
 else
        echo -e $RED" Build Failed"$ERED
        ((RES_CONF_FAIL++))
+       cat .dockererr
 fi
 cd $curdir
 
 cd ../cr
 echo " Building Callback Receiver image: callback-receiver:latest"
-docker build -t callback-receiver . &> /dev/null
+docker build -t callback-receiver . &> .dockererr
 if [ $? -eq 0 ]; then
        echo -e  $GREEN" Build Ok"$EGREEN
 else
        echo -e $RED" Build Failed"$ERED
        ((RES_CONF_FAIL++))
+       cat .dockererr
 fi
 cd $curdir
 
@@ -384,13 +549,21 @@ format_string="{{.Repository}}\\t{{.Tag}}\\t{{.CreatedSince}}\\t{{.Size}}"
 echo -e " Application\tRepository\tTag\tCreated Since\tSize" > $docker_tmp_file
 echo -e " Policy Agent\t$(docker images --format $format_string $POLICY_AGENT_IMAGE)" >>   $docker_tmp_file
 echo -e " Control Panel\t$(docker images --format $format_string $CONTROL_PANEL_IMAGE)" >>   $docker_tmp_file
-echo -e " SDNC A1 Controller\t$(docker images --format $format_string $SDNC_A1_CONTROLLER_IMAGE)" >>   $docker_tmp_file
 echo -e " RIC Simulator\t$(docker images --format $format_string $RIC_SIM_IMAGE)" >>   $docker_tmp_file
 echo -e " Message Router\t$(docker images --format $format_string $MRSTUB_IMAGE)" >>   $docker_tmp_file
 echo -e " Callback Receiver\t$(docker images --format $format_string $CR_IMAGE)" >>   $docker_tmp_file
 echo -e " Consul\t$(docker images --format $format_string $CONSUL_IMAGE)" >>   $docker_tmp_file
 echo -e " CBS\t$(docker images --format $format_string $CBS_IMAGE)" >>   $docker_tmp_file
-echo -e " SDNC DB\t$(docker images --format $format_string $SDNC_DB_IMAGE)" >>   $docker_tmp_file
+check_excluded_image 'SDNC'
+if [ $? -eq 0 ]; then
+       echo -e " SDNC A1 Controller\t$(docker images --format $format_string $SDNC_A1_CONTROLLER_IMAGE)" >>   $docker_tmp_file
+       echo -e " SDNC DB\t$(docker images --format $format_string $SDNC_DB_IMAGE)" >>   $docker_tmp_file
+fi
+check_excluded_image 'SDNC_ONAP'
+if [ $? -eq 0 ]; then
+       echo -e " SDNC ONAP A1 Adapter\t$(docker images --format $format_string $SDNC_ONAP_A1_ADAPTER_IMAGE)" >>   $docker_tmp_file
+       echo -e " SDNC ONAP DB\t$(docker images --format $format_string $SDNC_ONAP_DB_IMAGE)" >>   $docker_tmp_file
+fi
 
 column -t -s $'\t' $docker_tmp_file
 
@@ -420,6 +593,17 @@ print_result() {
        echo ""
 
 
+       if [ $RES_DEVIATION -gt 0 ]; then
+               echo "Test case deviations"
+               echo "===================================="
+               cat $DEVIATION_FILE
+       fi
+       echo ""
+       echo "Timer measurement in the test script"
+       echo "===================================="
+       column -t -s $'\t' $TIMER_MEASUREMENTS
+       echo ""
+
        total=$((RES_PASS+RES_FAIL))
        if [ $RES_TEST -eq 0 ]; then
                echo -e "\033[1mNo tests seem to have been executed. Check the script....\033[0m"
@@ -479,6 +663,9 @@ print_result() {
        echo "++++ Number of failed tests:   "$RES_FAIL
        echo ""
        echo "++++ Number of failed configs: "$RES_CONF_FAIL
+       echo ""
+       echo "++++ Number of test case deviations: "$RES_DEVIATION
+       echo ""
        echo "-------------------------------------     Test case complete    ---------------------------------"
        echo "-------------------------------------------------------------------------------------------------"
        echo ""
@@ -488,6 +675,73 @@ print_result() {
 ###### Functions for start, configuring, stoping, cleaning etc ######
 #####################################################################
 
+# Start timer for time measurement
+# args - (any args will be printed though)
+start_timer() {
+       echo -e $BOLD"INFO(${BASH_LINENO[0]}): "${FUNCNAME[0]}"," $@ $EBOLD
+       TC_TIMER=$SECONDS
+       echo " Timer started"
+}
+
+# Print the value of the time (in seconds)
+# args - <timer message to print>  -  timer value and message will be printed both on screen
+#                                     and in the timer measurement report
+print_timer() {
+       echo -e $BOLD"INFO(${BASH_LINENO[0]}): "${FUNCNAME[0]}"," $@ $EBOLD
+       if [ $# -lt 1 ]; then
+               ((RES_CONF_FAIL++))
+       __print_err "need 1 or more args,  <timer message to print>" $@
+               exit 1
+       fi
+       duration=$(($SECONDS-$TC_TIMER))
+       if [ $duration -eq 0 ]; then
+               duration="<1 second"
+       else
+               duration=$duration" seconds"
+       fi
+       echo " Timer duration :" $duration
+
+       echo -e "${@:1} \t $duration" >> $TIMER_MEASUREMENTS
+}
+
+# Print the value of the time (in seconds) and reset the timer
+# args - <timer message to print>  -  timer value and message will be printed both on screen
+#                                     and in the timer measurement report
+print_and_reset_timer() {
+       echo -e $BOLD"INFO(${BASH_LINENO[0]}): "${FUNCNAME[0]}"," $@ $EBOLD
+       if [ $# -lt 1 ]; then
+               ((RES_CONF_FAIL++))
+       __print_err "need 1 or more args,  <timer message to print>" $@
+               exit 1
+       fi
+       duration=$(($SECONDS-$TC_TIMER))" seconds"
+       if [ $duration -eq 0 ]; then
+               duration="<1 second"
+       else
+               duration=$duration" seconds"
+       fi
+       echo " Timer duration :" $duration
+       TC_TIMER=$SECONDS
+       echo " Timer reset"
+
+       echo -e "${@:1} \t $duration" >> $TIMER_MEASUREMENTS
+
+}
+# Print info about a deviations from intended tests
+# Each deviation counted is also printed in the testreport
+# args <deviation message to print>
+deviation() {
+       echo -e $BOLD"DEVIATION(${BASH_LINENO[0]}): "${FUNCNAME[0]} $EBOLD
+       if [ $# -lt 1 ]; then
+               ((RES_CONF_FAIL++))
+               __print_err "need 1 or more args,  <deviation message to print>" $@
+               exit 1
+       fi
+       ((RES_DEVIATION++))
+       echo -e $BOLD$YELLOW" Test case deviation: ${@:1}"$EYELLOW$EBOLD
+       echo "Line: ${BASH_LINENO[0]} - ${@:1}" >> $DEVIATION_FILE
+       echo ""
+}
 
 # Stop and remove all containers
 # args: -
@@ -503,6 +757,8 @@ clean_containers() {
                                          "Control Panel          " $CONTROL_PANEL_APP_NAME\
                                          "SDNC A1 Controller     " $SDNC_APP_NAME\
                                          "SDNC DB                " $SDNC_DB_APP_NAME\
+                                         "SDNC ONAP A1 Adapter   " $SDNC_ONAP_APP_NAME\
+                                         "SDNC DB                " $SDNC_ONAP_DB_APP_NAME\
                                          "CBS                    " $CBS_APP_NAME\
                                          "Consul                 " $CONSUL_APP_NAME)
 
@@ -519,14 +775,34 @@ clean_containers() {
                for((w=${#CONTR}; w<$nw; w=w+1)); do
                        CONTR="$CONTR "
                done
-               echo -ne " $APP: $CONTR - ${GREEN}stopping${EGREEN}\033[0K\r"
+               echo -ne " $APP: $CONTR - ${GREEN}stopping${EGREEN}${SAMELINE}"
                docker stop $(docker ps -qa --filter name=${CONTR}) &> /dev/null
-               echo -ne " $APP: $CONTR - ${GREEN}stopped${EGREEN}\033[0K\r"
-               docker rm $(docker ps -qa --filter name=${CONTR}) &> /dev/null
+               echo -ne " $APP: $CONTR - ${GREEN}stopped${EGREEN}${SAMELINE}"
+               docker rm --force $(docker ps -qa --filter name=${CONTR}) &> /dev/null
                echo -e  " $APP: $CONTR - ${GREEN}stopped removed${EGREEN}"
        done
 
        echo ""
+
+       echo -e $BOLD" Removing docker network"$EBOLD
+       TMP=$(docker network ls -q --filter name=$DOCKER_SIM_NWNAME)
+       if [ "$TMP" ==  $DOCKER_SIM_NWNAME ]; then
+               docker network rm $DOCKER_SIM_NWNAME
+               if [ $? -ne 0 ];  then
+                       echo -e $RED" Cannot remove docker network. Manually remove or disconnect containers from $DOCKER_SIM_NWNAME"$ERED
+                       exit 1
+               fi
+       fi
+
+       echo -e $BOLD" Removing all unused docker neworks"$EBOLD
+       docker network prune --force #&> /dev/null
+
+       echo -e $BOLD" Removing all unused docker volumes"$EBOLD
+       docker volume prune --force #&> /dev/null
+
+       echo -e $BOLD" Removing all dangling/untagged docker images"$EBOLD
+    docker rmi --force $(docker images -q -f dangling=true) &> /dev/null
+       echo ""
 }
 
 # Function stop and remove all container in the end of the test script, if the arg 'auto-clean' is given at test script start
@@ -555,11 +831,11 @@ sleep_wait() {
        start=$SECONDS
        duration=$((SECONDS-start))
        while [ $duration -lt $1 ]; do
-               echo -ne "  Slept for ${duration} seconds\033[0K\r"
+               echo -ne "  Slept for ${duration} seconds${SAMELINE}"
                sleep 1
                duration=$((SECONDS-start))
        done
-       echo -ne "  Slept for ${duration} seconds\033[0K\r"
+       echo -ne "  Slept for ${duration} seconds${SAMELINE}"
        echo ""
 }
 
@@ -578,8 +854,8 @@ __print_err() {
 # (Not for test scripts)
 __find_sim_port() {
     name=$1" " #Space appended to prevent matching 10 if 1 is desired....
-    cmdstr="docker ps --filter name=${name} --format \"{{.Names}} {{.Ports}}\" | grep '${name}' | sed s/0.0.0.0:// | cut -f 2 -d ' ' | cut -f 1 -d '-'"
-       res=$(eval $cmdstr)
+    cmdstr="docker inspect --format='{{(index (index .NetworkSettings.Ports \"$RIC_SIM_PORT/tcp\") 0).HostPort}}' ${name}"
+    res=$(eval $cmdstr)
        if [[ "$res" =~ ^[0-9]+$ ]]; then
                echo $res
        else
@@ -590,12 +866,12 @@ __find_sim_port() {
 # Function to create the docker network for the test
 # Not to be called from the test script itself.
 __create_docker_network() {
-       tmp=$(docker network ls -q --filter name=$DOCKER_SIM_NWNAME)
+       tmp=$(docker network ls --format={{.Name}} --filter name=$DOCKER_SIM_NWNAME)
        if [ $? -ne 0 ]; then
                echo -e $RED" Could not check if docker network $DOCKER_SIM_NWNAME exists"$ERED
                return 1
        fi
-       if [ -z tmp ]; then
+       if [ "$tmp" != $DOCKER_SIM_NWNAME ]; then
                echo -e "Creating docker network:$BOLD $DOCKER_SIM_NWNAME $EBOLD"
                docker network create $DOCKER_SIM_NWNAME
                if [ $? -ne 0 ]; then
@@ -608,62 +884,77 @@ __create_docker_network() {
 }
 
 # Check if container is started by calling url on localhost using a port, expects response code 2XX
-# args: <container-name> <port> <url>
+# args: <container-name> <port> <url> https|https
 # Not to be called from the test script itself.
 __check_container_start() {
-       if [ $# -ne 3 ]; then
+       paramError=0
+       if [ $# -ne 4 ]; then
+               paramError=1
+       elif [ $4 != "http" ] && [ $4 != "https" ]; then
+               paramError=1
+       fi
+       if [ $paramError -ne 0 ]; then
                ((RES_CONF_FAIL++))
-               __print_err "need 3 args, <container-name> <port> <url>" $@
+               __print_err "need 3 args, <container-name> <port> <url> https|https" $@
                return 1
        fi
-       echo -ne " Container $BOLD$1$EBOLD starting\033[0K\r"
+       echo -ne " Container $BOLD$1$EBOLD starting${SAMELINE}"
        appname=$1
        localport=$2
        url=$3
-       pa_started=false
-       for i in {1..10}; do
-               if [ $(docker inspect --format '{{ .State.Running }}' $appname) ]; then
-                               echo -e " Container $BOLD$1$EBOLD$GREEN running$EGREEN on$BOLD image $(docker inspect --format '{{ .Config.Image }}' ${appname}) $EBOLD"
-                               pa_started=true
-                               break
-                       else
-                               sleep $i
-               fi
-       done
-       if ! [ $pa_started  ]; then
-               ((RES_CONF_FAIL++))
-               echo ""
-               echo -e $RED" Container $BOLD${appname}$EBOLD could not be started"$ERED
-               return 1
-       fi
-       if [ $localport -eq 0 ]; then
-               while [ $localport -eq 0 ]; do
-                       echo -ne " Waiting for container ${appname} to publish its ports...\033[0K\r"
-                       localport=$(__find_sim_port $appname)
-                       sleep 1
-                       echo -ne " Waiting for container ${appname} to publish its ports...retrying....\033[0K\r"
+       if [[ $appname != "STANDALONE_"* ]]     ; then
+               app_started=0
+               for i in {1..10}; do
+                       if [ "$(docker inspect --format '{{ .State.Running }}' $appname)" == "true" ]; then
+                                       echo -e " Container $BOLD$1$EBOLD$GREEN running$EGREEN on$BOLD image $(docker inspect --format '{{ .Config.Image }}' ${appname}) $EBOLD"
+                                       app_started=1
+                                       break
+                               else
+                                       sleep $i
+                       fi
                done
-               echo -ne " Waiting for container ${appname} to publish its ports...retrying....$GREEN OK $EGREEN"
-               echo ""
+               if [ $app_started -eq 0 ]; then
+                       ((RES_CONF_FAIL++))
+                       echo ""
+                       echo -e $RED" Container $BOLD${appname}$EBOLD could not be started"$ERED
+                       return 1
+               fi
+               if [ $localport -eq 0 ]; then
+                       while [ $localport -eq 0 ]; do
+                               echo -ne " Waiting for container ${appname} to publish its ports...${SAMELINE}"
+                               localport=$(__find_sim_port $appname)
+                               sleep 1
+                               echo -ne " Waiting for container ${appname} to publish its ports...retrying....${SAMELINE}"
+                       done
+                       echo -ne " Waiting for container ${appname} to publish its ports...retrying....$GREEN OK $EGREEN"
+                       echo ""
+               fi
        fi
 
        pa_st=false
-       echo -ne " Waiting for container ${appname} service status...\033[0K\r"
-       for i in {1..20}; do
-               result="$(__do_curl $LOCALHOST${localport}${url})"
+       echo -ne " Waiting for container ${appname} service status...${SAMELINE}"
+       TSTART=$SECONDS
+       for i in {1..50}; do
+               if [ $4 == "https" ]; then
+                       result="$(__do_curl "-k https://localhost:"${localport}${url})"
+               else
+                       result="$(__do_curl $LOCALHOST${localport}${url})"
+               fi
                if [ $? -eq 0 ]; then
                        if [ ${#result} -gt 15 ]; then
                                #If response is too long, truncate
                                result="...response text too long, omitted"
                        fi
-                       echo -ne " Waiting for container $BOLD${appname}$EBOLD service status, result: $result\033[0K\r"
-                       echo -ne " Container $BOLD${appname}$EBOLD$GREEN is alive$EGREEN, responds to service status:$GREEN $result $EGREEN"
+                       echo -ne " Waiting for container $BOLD${appname}$EBOLD service status, result: $result${SAMELINE}"
+                       echo -ne " Container $BOLD${appname}$EBOLD$GREEN is alive$EGREEN, responds to service status:$GREEN $result $EGREEN after $(($SECONDS-$TSTART)) seconds"
                        pa_st=true
                        break
                else
-                       #echo " Retrying in $i seconds"
-                       echo -ne " Waiting for container ${appname} service status...retrying in $i seconds\033[0K\r"
-                       sleep $i
+                       TS_TMP=$SECONDS
+                       while [ $(($TS_TMP+$i)) -gt $SECONDS ]; do
+                               echo -ne " Waiting for container ${appname} service status...retrying in $(($TS_TMP+$i-$SECONDS)) seconds   ${SAMELINE}"
+                               sleep 1
+                       done
                fi
        done
 
@@ -683,9 +974,9 @@ __check_container_start() {
 __start_container() {
 
        variableArgCount=$(($#-2))
-       if [ $# -lt 5 ] && [ [ $(($variableArgCount%3)) -ne 0 ]; then
+       if [ $# -lt 6 ] && [ [ $(($variableArgCount%4)) -ne 0 ]; then
                ((RES_CONF_FAIL++))
-       __print_err "need 5 or more args,  <docker-compose-dir> NODOCKERARGS|<docker-compose-arg> <app-name> <port-number> <alive-url> [<app-name> <port-number> <alive-url>]*" $@
+       __print_err "need 6 or more args,  <docker-compose-dir> NODOCKERARGS|<docker-compose-arg> <app-name> <port-number> <alive-url> http|https [<app-name> <port-number> <alive-url> http|https ]*" $@
                exit 1
        fi
 
@@ -696,20 +987,34 @@ __start_container() {
        cd $1
 
        if [ "$2" == "NODOCKERARGS" ]; then
-               docker-compose up -d &> /dev/null
+               docker-compose up -d &> .dockererr
+               if [ $? -ne 0 ]; then
+                       echo -e $RED"Problem to launch container(s) with docker-compose"$ERED
+                       cat .dockererr
+               fi
+       elif [ "$2" == "STANDALONE" ]; then
+               echo "Skipping docker-compose"
        else
-               docker-compose up -d $2 &> /dev/null
+               docker-compose up -d $2 &> .dockererr
+               if [ $? -ne 0 ]; then
+                       echo -e $RED"Problem to launch container(s) with docker-compose"$ERED
+                       cat .dockererr
+               fi
+       fi
+       app_prefix=""
+       if [ "$2" == "STANDALONE" ]; then
+               app_prefix="STANDALONE_"
        fi
-
        shift; shift;
        cntr=0
        while [ $cntr -lt $variableArgCount ]; do
-               app=$1; shift;
+               app=$app_prefix$1; shift;
                port=$1; shift;
                url=$1; shift;
-               let cntr=cntr+3
+               httpx=$1; shift;
+               let cntr=cntr+4
 
-               __check_container_start "$app" "$port" "$url"
+               __check_container_start "$app" "$port" "$url" $httpx
        done
 
        cd $curdir
@@ -743,6 +1048,7 @@ consul_config_app() {
                return 1
        fi
        body="$(__do_curl $LOCALHOST$CBS_EXTERNAL_PORT/service_component_all/$POLICY_AGENT_APP_NAME)"
+       echo $body > ".output"$1
 
        if [ $? -ne 0 ]; then
                echo -e $RED" FAIL - json config could not be loaded from consul/cbs, contents cannot be checked." $ERED
@@ -752,7 +1058,7 @@ consul_config_app() {
                targetJson=$(< $1)
                targetJson="{\"config\":"$targetJson"}"
                echo "TARGET JSON: $targetJson" >> $HTTPLOG
-               res=$(python ../common/compare_json.py "$targetJson" "$body")
+               res=$(python3 ../common/compare_json.py "$targetJson" "$body")
                if [ $res -ne 0 ]; then
                        echo -e $RED" FAIL - policy json config read from consul/cbs is not equal to the intended json config...." $ERED
                        ((RES_CONF_FAIL++))
@@ -767,7 +1073,7 @@ consul_config_app() {
 }
 
 # Function to perpare the consul configuration according to the current simulator configuration
-# args: SDNC|NOSDNC <output-file>
+# args: SDNC|SDNC_ONAP|NOSDNC <output-file>
 # (Function for test scripts)
 prepare_consul_config() {
        echo -e $BOLD"Prepare Consul config"$EBOLD
@@ -776,17 +1082,19 @@ prepare_consul_config() {
 
        if [ $# != 2 ];  then
                ((RES_CONF_FAIL++))
-       __print_err "need two args,  SDNC|NOSDNC <output-file>" $@
+       __print_err "need two args,  SDNC|SDNC_ONAP|NOSDNC <output-file>" $@
                exit 1
        fi
 
        if [ $1 == "SDNC" ]; then
                echo -e " Config$BOLD including SDNC$EBOLD configuration"
+       elif [ $1 == "SDNC_ONAP" ]; then
+               echo -e " Config$BOLD including SDNC ONAP$EBOLD configuration"
        elif [ $1 == "NOSDNC" ];  then
-               echo -e " Config$BOLD excluding SDNC$EBOLD configuration"
+               echo -e " Config$BOLD excluding SDNC or SDNC ONAP$EBOLD configuration"
        else
                ((RES_CONF_FAIL++))
-       __print_err "need two args,  SDNC|NOSDNC <output-file>" $@
+       __print_err "need two args,  SDNC|SDNC_ONAP|NOSDNC <output-file>" $@
                exit 1
        fi
 
@@ -795,19 +1103,41 @@ prepare_consul_config() {
                config_json=$config_json"\n   \"controller\": ["
                config_json=$config_json"\n                     {"
                config_json=$config_json"\n                       \"name\": \"$SDNC_APP_NAME\","
-               config_json=$config_json"\n                       \"baseUrl\": \"http://$SDNC_APP_NAME:$SDNC_INTERNAL_PORT\","
+               if [ $AGENT_STAND_ALONE -eq 0 ]; then
+                       config_json=$config_json"\n                       \"baseUrl\": \"$SDNC_HTTPX://$SDNC_APP_NAME:$SDNC_PORT\","
+               else
+                       config_json=$config_json"\n                       \"baseUrl\": \"$SDNC_HTTPX://localhost:$SDNC_LOCAL_PORT\","
+               fi
                config_json=$config_json"\n                       \"userName\": \"$SDNC_USER\","
                config_json=$config_json"\n                       \"password\": \"$SDNC_PWD\""
                config_json=$config_json"\n                     }"
                config_json=$config_json"\n   ],"
        fi
+       if [ $1 == "SDNC_ONAP" ]; then
+               config_json=$config_json"\n   \"controller\": ["
+               config_json=$config_json"\n                     {"
+               config_json=$config_json"\n                       \"name\": \"$SDNC_ONAP_APP_NAME\","
+               if [ $AGENT_STAND_ALONE -eq 0 ]; then
+                       config_json=$config_json"\n                       \"baseUrl\": \"http://$SDNC_ONAP_APP_NAME:$SDNC_ONAP_INTERNAL_PORT\","
+               else
+                       config_json=$config_json"\n                       \"baseUrl\": \"http://localhost:$SDNC_ONAP_EXTERNAL_PORT\","
+               fi
+               config_json=$config_json"\n                       \"userName\": \"$SDNC_ONAP_USER\","
+               config_json=$config_json"\n                       \"password\": \"$SDNC_ONAP_PWD\""
+               config_json=$config_json"\n                     }"
+               config_json=$config_json"\n   ],"
+       fi
 
 
        config_json=$config_json"\n   \"streams_publishes\": {"
        config_json=$config_json"\n                            \"dmaap_publisher\": {"
        config_json=$config_json"\n                              \"type\": \"$MR_APP_NAME\","
        config_json=$config_json"\n                              \"dmaap_info\": {"
-       config_json=$config_json"\n                                \"topic_url\": \"http://$MR_APP_NAME:$MR_INTERNAL_PORT/events/A1-POLICY-AGENT-WRITE\""
+       if [ $AGENT_STAND_ALONE -eq 0 ]; then
+               config_json=$config_json"\n                                \"topic_url\": \"$MR_HTTPX://$MR_APP_NAME:$MR_PORT$MR_WRITE_URL\""
+       else
+               config_json=$config_json"\n                                \"topic_url\": \"$MR_HTTPX://localhost:$MR_LOCAL_PORT$MR_WRITE_URL\""
+       fi
        config_json=$config_json"\n                              }"
        config_json=$config_json"\n                            }"
        config_json=$config_json"\n   },"
@@ -815,7 +1145,11 @@ prepare_consul_config() {
        config_json=$config_json"\n                             \"dmaap_subscriber\": {"
        config_json=$config_json"\n                               \"type\": \"$MR_APP_NAME\","
        config_json=$config_json"\n                               \"dmaap_info\": {"
-       config_json=$config_json"\n                                   \"topic_url\": \"http://$MR_APP_NAME:$MR_INTERNAL_PORT/events/A1-POLICY-AGENT-READ/users/policy-agent\""
+       if [ $AGENT_STAND_ALONE -eq 0 ]; then
+               config_json=$config_json"\n                                   \"topic_url\": \"$MR_HTTPX://$MR_APP_NAME:$MR_PORT$MR_READ_URL\""
+       else
+               config_json=$config_json"\n                                   \"topic_url\": \"$MR_HTTPX://localhost:$MR_LOCAL_PORT$MR_READ_URL\""
+       fi
        config_json=$config_json"\n                                 }"
        config_json=$config_json"\n                               }"
        config_json=$config_json"\n   },"
@@ -837,9 +1171,15 @@ prepare_consul_config() {
                fi
                config_json=$config_json"\n          {"
                config_json=$config_json"\n            \"name\": \"$ric\","
-               config_json=$config_json"\n            \"baseUrl\": \"http://$ric:$RIC_SIM_INTERNAL_PORT\","
+               if [ $AGENT_STAND_ALONE -eq 0 ]; then
+                       config_json=$config_json"\n            \"baseUrl\": \"$RIC_SIM_HTTPX://$ric:$RIC_SIM_PORT\","
+               else
+                       config_json=$config_json"\n            \"baseUrl\": \"$RIC_SIM_HTTPX://localhost:$(__find_sim_port $ric)\","
+               fi
                if [ $1 == "SDNC" ]; then
                        config_json=$config_json"\n            \"controller\": \"$SDNC_APP_NAME\","
+               elif [ $1 == "SDNC_ONAP" ]; then
+                       config_json=$config_json"\n            \"controller\": \"$SDNC_ONAP_APP_NAME\","
                fi
                config_json=$config_json"\n            \"managedElementIds\": ["
                config_json=$config_json"\n              \"me1_$ric\","
@@ -866,14 +1206,30 @@ start_consul_cbs() {
 
        echo -e $BOLD"Starting Consul and CBS"$EBOLD
 
-       __start_container consul_cbs NODOCKERARGS  "$CONSUL_APP_NAME" "$CONSUL_EXTERNAL_PORT" "/ui/dc1/kv" \
-                                                    "$CBS_APP_NAME" "$CBS_EXTERNAL_PORT" "/healthcheck"
+       __start_container consul_cbs NODOCKERARGS  "$CONSUL_APP_NAME" "$CONSUL_EXTERNAL_PORT" "/ui/dc1/kv" "http" \
+                                                    "$CBS_APP_NAME" "$CBS_EXTERNAL_PORT" "/healthcheck" "http"
 }
 
 ###########################
 ### RIC Simulator functions
 ###########################
 
+use_simulator_http() {
+       echo -e "Using unsecure $BOLD http $EBOLD towards the simulators"
+       export RIC_SIM_HTTPX="http"
+       export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
+       export RIC_SIM_PORT=$RIC_SIM_INTERNAL_PORT
+       echo ""
+}
+
+use_simulator_https() {
+       echo -e "Using secure $BOLD https $EBOLD towards the simulators"
+       export RIC_SIM_HTTPX="https"
+       export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
+       export RIC_SIM_PORT=$RIC_SIM_INTERNAL_SECURE_PORT
+       echo ""
+}
+
 # Start one group (ricsim_g1, ricsim_g2 or ricsim_g3) with a number of RIC Simulators using a given A interface
 # args:  ricsim_g1|ricsim_g2|ricsim_g3 <count> <interface-id>
 # (Function for test scripts)
@@ -916,10 +1272,9 @@ start_ric_simulators() {
        while [ $cntr -le $2 ]; do
                app=$1"_"$cntr
                port=0
-               app_data="$app_data $app $port /"
+               app_data="$app_data $app $port / "$RIC_SIM_HTTPX
                let cntr=cntr+1
        done
-
        __start_container ric "$docker_args" $app_data
 
 }
@@ -935,7 +1290,7 @@ start_control_panel() {
 
        echo -e $BOLD"Starting Control Panel"$EBOLD
 
-       __start_container control_panel NODOCKERARGS $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_EXTERNAL_PORT "/"
+       __start_container control_panel NODOCKERARGS $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_EXTERNAL_PORT "/" "http"
 
 }
 
@@ -950,10 +1305,89 @@ start_sdnc() {
 
        echo -e $BOLD"Starting SDNC A1 Controller"$EBOLD
 
-       __start_container sdnc NODOCKERARGS $SDNC_APP_NAME $SDNC_EXTERNAL_PORT "/apidoc/explorer"
+       check_excluded_image 'SDNC'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The image for SDNC and the related DB has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"SDNC will not be started"$ERED
+               exit
+       fi
+
+       __start_container sdnc NODOCKERARGS $SDNC_APP_NAME $SDNC_EXTERNAL_PORT $SDNC_ALIVE_URL "http"
+
+}
+
+use_sdnc_http() {
+       echo -e $BOLD"Using http between agent and SDNC"$EBOLD
+       export SDNC_HTTPX="http"
+       export SDNC_PORT=$SDNC_INTERNAL_PORT
+       export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_PORT
+       echo ""
+}
+
+use_sdnc_https() {
+       echo -e $BOLD"Using https between agent and SDNC"$EBOLD
+       export SDNC_HTTPX="https"
+       export SDNC_PORT=$SDNC_INTERNAL_SECURE_PORT
+       export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_SECURE_PORT
+       echo ""
+}
+
+#######################
+### SDNC ONAP functions
+#######################
+
+# Start the SDNC ONAP A1 Adapter
+# args: -
+# (Function for test scripts)
+start_sdnc_onap() {
+
+       echo -e $BOLD"Starting SDNC ONAP A1 Adapter"$EBOLD
+
+       check_excluded_image 'SDNC_ONAP'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The image for SDNC ONAP and the related DB has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"SDNC ONAP will not be started"$ERED
+               exit
+       fi
+
+       __start_container sdnc_onap NODOCKERARGS $SDNC_ONAP_APP_NAME $SDNC_ONAP_EXTERNAL_PORT $SDNC_ONAP_ALIVE_URL "http"
 
 }
 
+# Configure the SDNC ONAP A1 Adapter
+# args: -
+# (Function for test scripts)
+config_sdnc_onap() {
+
+       echo -e $BOLD"Configuring SDNC ONAP A1 Adapter"$EBOLD
+
+       LOCALFILE=".sdnc_onap.prop"
+       REMOTEFILE="/tmp/.sdnc_onap.prop"
+
+       docker cp $SDNC_ONAP_APP_NAME:$SDNC_ONAP_PROPERTIES_FILE $LOCALFILE
+       if [ $? -ne 0 ]; then
+               echo -e $RED"Could not copy $SDNC_ONAP_PROPERTIES_FILE from $SDNC_ONAP_APP_NAME container"$ERED
+               exit 1
+       fi
+
+
+       #Config of the prop file shall be inserted here
+
+       #Copy file to /tmp and then to final destination, a trick to get correct permission of the file.
+
+       docker cp $LOCALFILE $SDNC_ONAP_APP_NAME:$REMOTEFILE
+       if [ $? -ne 0 ]; then
+               echo -e $RED"Could not copy local $LOCALFILE to $REMOTEFILE in $SDNC_ONAP_APP_NAME container"$ERED
+               exit 1
+       fi
+
+       docker exec -it $SDNC_ONAP_APP_NAME cp $REMOTEFILE $SDNC_ONAP_PROPERTIES_FILE
+       if [ $? -ne 0 ]; then
+               echo -e $RED"Could not copy $REMOTEFILE to $SDNC_ONAP_PROPERTIES_FILE in $SDNC_ONAP_APP_NAME container"$ERED
+               exit 1
+       fi
+}
+
 #####################
 ### MR stub functions
 #####################
@@ -964,11 +1398,27 @@ start_sdnc() {
 start_mr() {
 
        echo -e $BOLD"Starting Message Router 'mrstub'"$EBOLD
+       export MR_CERT_MOUNT_DIR="./cert"
+       __start_container mr NODOCKERARGS $MR_APP_NAME $MR_EXTERNAL_PORT "/" "http"
+}
 
-       __start_container mr NODOCKERARGS $MR_APP_NAME $MR_EXTERNAL_PORT "/"
+use_mr_http() {
+       echo -e $BOLD"Using http between agent and MR"$EBOLD
+       export MR_HTTPX="http"
+       export MR_PORT=$MR_INTERNAL_PORT
+       export MR_LOCAL_PORT=$MR_EXTERNAL_PORT
+       echo ""
+}
 
+use_mr_https() {
+       echo -e $BOLD"Using https between agent and MR"$EBOLD
+       export MR_HTTPX="https"
+       export MR_PORT=$MR_INTERNAL_SECURE_PORT
+       export MR_LOCAL_PORT=$MR_EXTERNAL_SECURE_PORT
+       echo ""
 }
 
+
 ################
 ### CR functions
 ################
@@ -980,7 +1430,7 @@ start_cr() {
 
        echo -e $BOLD"Starting Callback Receiver"$EBOLD
 
-       __start_container cr NODOCKERARGS $CR_APP_NAME $CR_EXTERNAL_PORT "/"
+       __start_container cr NODOCKERARGS $CR_APP_NAME $CR_EXTERNAL_PORT "/" "http"
 
 }
 
@@ -988,36 +1438,63 @@ start_cr() {
 ### Policy Agents functions
 ###########################
 
-# Start the policy agwent
+# Use an agent on the local machine instead of container
+use_agent_stand_alone() {
+       AGENT_STAND_ALONE=1
+}
+
+# Start the policy agent
 # args: -
 # (Function for test scripts)
 start_policy_agent() {
 
        echo -e $BOLD"Starting Policy Agent"$EBOLD
 
-       __start_container policy_agent NODOCKERARGS $POLICY_AGENT_APP_NAME $POLICY_AGENT_EXTERNAL_PORT "/status"
+       if [ $AGENT_STAND_ALONE -eq 0 ]; then
+               __start_container policy_agent NODOCKERARGS $POLICY_AGENT_APP_NAME $POLICY_AGENT_EXTERNAL_PORT "/status" "http"
+       else
+               echo -e $RED"The consul config produced by this test script (filename '<fullpath-to-autotest-dir>.output<file-name>"$ERED
+               echo -e $RED"where the file name is the file in the consul_config_app command in this script) must be pointed out by the agent "$ERED
+               echo -e $RED"application.yaml"$ERED
+               echo -e $RED"The application jar may need to be built beforefor continuing"$ERED
+               echo -e $RED"The agent shall now be running on port $POLICY_AGENT_EXTERNAL_PORT for http"$ERED
+
+               read -p "<press any key to continue>"
+               __start_container policy_agent "STANDALONE" $POLICY_AGENT_APP_NAME $POLICY_AGENT_EXTERNAL_PORT "/status" "http"
+       fi
 
 }
 
 # All calls to the agent will be directed to the agent REST interface from now on
 # args: -
 # (Function for test scripts)
-use_agent_rest() {
-       echo -e $BOLD"Using agent REST interface"$EBOLD
+use_agent_rest_http() {
+       echo -e $BOLD"Using agent REST interface with http"$EBOLD
        export ADAPTER=$RESTBASE
        echo ""
 }
 
+# All calls to the agent will be directed to the agent REST interface from now on
+# args: -
+# (Function for test scripts)
+use_agent_rest_https() {
+       echo -e $BOLD"Using agent REST interface with https"$EBOLD
+       export ADAPTER=$RESTBASE_SECURE
+       echo ""
+       return 0
+}
+
 # All calls to the agent will be directed to the agent dmaap interface from now on
 # args: -
 # (Function for test scripts)
 use_agent_dmaap() {
-       echo -e $BOLD"Using agent DMAAP interface"$EBOLD
+       echo -e $BOLD"Agent using DMAAP interface"$EBOLD
        export ADAPTER=$DMAAPBASE
        echo ""
-
+       return 0
 }
 
+
 # Turn on debug level tracing in the agent
 # args: -
 # (Function for test scripts)
@@ -1028,8 +1505,8 @@ set_agent_debug() {
                __print_err "could not set debug mode" $@
                return 1
        fi
-       return 0
        echo ""
+       return 0
 }
 
 # Perform curl retries when making direct call to the agent for the specified http response codes
@@ -1039,6 +1516,7 @@ use_agent_retries() {
        echo -e $BOLD"Do curl retries to the agent REST inteface for these response codes:$@"$EBOLD
        AGENT_RETRY_CODES=$@
        echo ""
+       return
 }
 
 #################
@@ -1102,8 +1580,9 @@ store_logs() {
        __print_err "need one arg, <file-prefix>" $@
                exit 1
        fi
-       echo -e $BOLD"Storing all container logs, Policy Agent app log and consul config using prefix: "$1
+       echo -e $BOLD"Storing all container logs, Policy Agent app log and consul config using prefix: "$1$EBOLD
 
+       docker stats --no-stream > $TESTLOGS/$ATC/$1_docker_stats.log 2>&1
        docker logs $CONSUL_APP_NAME > $TESTLOGS/$ATC/$1_consul.log 2>&1
        docker logs $CBS_APP_NAME > $TESTLOGS/$ATC/$1_cbs.log 2>&1
        docker logs $POLICY_AGENT_APP_NAME > $TESTLOGS/$ATC/$1_policy-agent.log 2>&1
@@ -1112,7 +1591,9 @@ store_logs() {
        docker logs $CR_APP_NAME > $TESTLOGS/$ATC/$1_cr.log 2>&1
        cp .httplog_${ATC}.txt $TESTLOGS/$ATC/$1_httplog_${ATC}.txt 2>&1
 
-       docker exec -it $SDNC_APP_NAME cat /opt/opendaylight/data/log/karaf.log > $TESTLOGS/$ATC/$1_karaf.log 2>&1
+       docker exec -it $SDNC_APP_NAME cat $SDNC_KARAF_LOG> $TESTLOGS/$ATC/$1_SDNC_karaf.log 2>&1
+
+       docker exec -it $SDNC_ONAP_APP_NAME cat $SDNC_ONAP_KARAF_LOG > $TESTLOGS/$ATC/$1_SDNC_ONAP_karaf.log 2>&1
 
        rics=$(docker ps -f "name=$RIC_SIM_PREFIX" --format "{{.Names}}")
        for ric in $rics; do
@@ -1176,7 +1657,7 @@ __var_test() {
                fi
 
                #echo -e "---- ${1} sim test criteria: \033[1m ${3} \033[0m ${4} ${5} within ${6} seconds ----"
-               echo -e $BOLD"TEST(${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5} within ${6} seconds"
+               echo -e $BOLD"TEST(${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5} within ${6} seconds"$EBOLD
                ((RES_TEST++))
                start=$SECONDS
                ctr=0
@@ -1190,10 +1671,10 @@ __var_test() {
                                result="$(__do_curl $2$path)"
                                retcode=$?
                                echo "$result" > .tmp.curl.json
-                               result=$(python ../common/count_json_elements.py ".tmp.curl.json")
+                               result=$(python3 ../common/count_json_elements.py ".tmp.curl.json")
                        fi
                        duration=$((SECONDS-start))
-                       echo -ne " Result=${result} after ${duration} seconds\033[0K\r"
+                       echo -ne " Result=${result} after ${duration} seconds${SAMELINE}"
                        let ctr=ctr+1
                        if [ $retcode -ne 0 ]; then
                                if [ $duration -gt $6 ]; then
@@ -1204,25 +1685,25 @@ __var_test() {
                                fi
                        elif [ $4 = "=" ] && [ "$result" -eq $5 ]; then
                                ((RES_PASS++))
-                               echo -e " Result=${result} after ${duration} seconds\033[0K\r"
+                               echo -e " Result=${result} after ${duration} seconds${SAMELINE}"
                                echo -e $GREEN" PASS${EGREEN} - Result=${result} after ${duration} seconds"
                                #echo -e "----  \033[32m\033[1mPASS\033[0m - Test criteria met in ${duration} seconds ----"
                                return
                        elif [ $4 = ">" ] && [ "$result" -gt $5 ]; then
                                ((RES_PASS++))
-                               echo -e " Result=${result} after ${duration} seconds\033[0K\r"
+                               echo -e " Result=${result} after ${duration} seconds${SAMELINE}"
                                echo -e $GREEN" PASS${EGREEN} - Result=${result} after ${duration} seconds"
                                #echo -e "----  \033[32m\033[1mPASS\033[0m - Test criteria met in ${duration} seconds, result = ${result}  ----"
                                return
                        elif [ $4 = "<" ] && [ "$result" -lt $5 ]; then
                                ((RES_PASS++))
-                               echo -e " Result=${result} after ${duration} seconds\033[0K\r"
+                               echo -e " Result=${result} after ${duration} seconds${SAMELINE}"
                                echo -e $GREEN" PASS${EGREEN} - Result=${result} after ${duration} seconds"
                                #echo -e "----  \033[32m\033[1mPASS\033[0m - Test criteria met in ${duration} seconds, result = ${result}  ----"
                                return
                        elif [ $4 = "contain_str" ] && [[ $result =~ $5 ]]; then
                                ((RES_PASS++))
-                               echo -e " Result=${result} after ${duration} seconds\033[0K\r"
+                               echo -e " Result=${result} after ${duration} seconds${SAMELINE}"
                                echo -e $GREEN" PASS${EGREEN} - Result=${result} after ${duration} seconds"
                                #echo -e "----  \033[32m\033[1mPASS\033[0m - Test criteria met in ${duration} seconds, result = ${result}  ----"
                                return
@@ -1253,7 +1734,7 @@ __var_test() {
                        result="$(__do_curl $2$path)"
                        retcode=$?
                        echo "$result" > .tmp.curl.json
-                       result=$(python ../common/count_json_elements.py ".tmp.curl.json")
+                       result=$(python3 ../common/count_json_elements.py ".tmp.curl.json")
                fi
                if [ $retcode -ne 0 ]; then
                        ((RES_FAIL++))
@@ -1331,7 +1812,7 @@ mr_equal() {
 # (Function for test scripts)
 mr_greater() {
        if [ $# -eq 2 ] || [ $# -eq 3 ]; then
-               __var_test "MR" "$LOCALHOST$MR_EXTERNAL_PORT/counter/" $1 "=" $2 $3
+               __var_test "MR" "$LOCALHOST$MR_EXTERNAL_PORT/counter/" $1 ">" $2 $3
        else
                ((RES_CONF_FAIL++))
                __print_err "Wrong args to mr_greater, needs two or three args: <sim-param> <target-value> [ timeout ]" $@
@@ -1354,5 +1835,3 @@ mr_print() {
        fi
        echo -e $BOLD"INFO(${BASH_LINENO[0]}): mrstub, $1 = $(__do_curl $LOCALHOST$MR_EXTERNAL_PORT/counter/$1)"$EBOLD
 }
-
-